{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        init : function(){
            var t = this;
            t.gridLoaded=false;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            t.windowButtons.formCancel=false;
            t.checks = {};
	        t.stationData = {};
            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.numberField({
                        title : "{{ 'Reports.year'|trans }}",
                        dataIndex : 'year',
                        labelWidth : '110px',
                        width : 30,
                        defaultZero : false,
                        notEmpty:true
                    }),
                    new mj.form.textArea({
                        title : "{{ 'Reports.opnames'|trans }}",
                        dataIndex : 'opname',
                        labelWidth : '110px',
                        width:300,
                        height:80
                    }),
                    new mj.form.textArea({
                        title : "{{ 'Reports.clients'|trans }}",
                        dataIndex : 'client',
                        labelWidth : '110px',
                        width:300,
                        height:80,
                        itemStyle:"position:absolute;top:120px;left:5px;"
                    })
                ]
            };

            t._setFormConfig(formConfig,t.initFormElementsEvents);
            t.tabPanels.main.setActive(0);
        },
        editSelectedRecord: function(){
            return;
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    t.waitMaskShow();
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {'pg':1,'lm':25};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    data.menuId = t.id;
                    data.reportname = t.reportname;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'binary',
                            processData: false,
                            success: function(data, textStatus, xhr) {
                                //t.activateTabGrid();
                                if(textStatus==='success'){
                                    var filename = "";
                                    var disposition = xhr.getResponseHeader('Content-Disposition');
                                    if (disposition && disposition.indexOf('attachment') !== -1) {
                                        var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                                        var matches = filenameRegex.exec(disposition);
                                        if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                                    }
                                    var type = xhr.getResponseHeader('Content-Type');
                                    var blob = typeof File === 'function'
                                        ? new File([data], filename, { type: type })
                                        : new Blob([data], { type: type });
                                    if (typeof window.navigator.msSaveBlob !== 'undefined') {
                                        // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
                                        window.navigator.msSaveBlob(blob, filename);
                                        t.waitMaskHide();
                                    } else {
                                        var URL = window.URL || window.webkitURL;
                                        var downloadUrl = URL.createObjectURL(blob);
                                        if (filename) {
                                            // use HTML5 a[download] attribute to specify filename
                                            var a = document.createElement("a");
                                            // safari doesn't support this yet
                                            if (typeof a.download === 'undefined') {
                                                window.location = downloadUrl;
                                                t.waitMaskHide();
                                            } else {
                                                a.href = downloadUrl;
                                                a.download = filename;
                                                document.body.appendChild(a);
                                                a.click();
                                                t.waitMaskHide();
                                            }
                                        } else {
                                            window.location = downloadUrl;
                                            t.waitMaskHide();
                                        }

                                        setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
                                    }
                                }
                            },
                            error: function(xhr, textStatus, errorThrown) {
                                t.waitMaskHide();
                                if(xhr.responseJSON&&xhr.responseJSON.message){
                                    mj.message({
                                        title: mj.lng.glb.error,
                                        msg: xhr.responseJSON.message,
                                        type: "error",
                                        html: true
                                    });
                                }
                            },
                            complete: function(jqXHR, textStatus) {
                                t.waitMaskHide();
                            }
                        });
                    }
                    
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
